(module mv mzscheme
  (require "redex.scm"
           (lib "list.ss"))
   
  (define lang
    (language
     (p (store (sf ...) e))
     (sf (x v))
     (e (e e ...)
        (set! x e)
        (begin e e ...)
        (if e e e)
        x
        v)
     
     (v (lambda (x ...) e)
        n #t #f - 
        unspecified
        call-with-values
        values)
     
     (P (store (sf ...) E*))
     
     (E (v ... Eo e ...)
        (set! x Eo)
        (begin E* e e ...)
        (if Eo e e)
        (call-with-values (lambda () E*) v)
        hole)
     
     (Eo E
         (hole single))
     
     (E* E
         (hole multi))
     
     (x (variable-except set! begin if lambda unspecified values call-with-values -))
     (n number)))
  
  (define reductions
    (reduction-relation
     lang
     (--> (in-named-hole multi P_1 v_1)
          (in-hole P_1 (values v_1))
          "VPromote")
     
     (--> (in-named-hole single P_1 (values v_1))
          (in-hole P_1 v_1)
          "VDemote")
     
     (--> (in-named-hole single P_1 (values v_1 ...))
          (error "context received wrong # of values")
          (side-condition (not (= (length (term (v_1 ...))) 1)))
          "VDemoteErr")
     
     ; call-with-values
     (--> (in-hole P_1 (call-with-values (lambda () (values v_2 ...)) v_1))
          (in-hole P_1 (v_1 v_2 ...))
          "VCwv")
     
     (--> (in-hole P_1 (call-with-values v_1 v_2))
          (in-hole P_1 (call-with-values (lambda () (v_1)) v_2))
          (side-condition (not (thunk? (term v_1))))
          "VCwvApp")
     
     (--> (store ((x_s v_s) ...) 
            (in-hole E*_1 ((lambda (x_1 ...) e_body) v_1 ...)))
          (store ((x_s v_s) ... (x v_1) ...)
            (in-hole E*_1 ,(lc-subst-all (term (x_1 ...)) 
                                         (term (x ...))
                                         (term e_body))))
          (side-condition (= (length (term (x_1 ...))) (length (term (v_1 ...)))))
          (fresh ((x ...) (x_1 ...)))
          "VApp")
     
     (--> (store ((x_1 v_1) ... (x_x v_orig) (x_2 v_2) ...) (in-hole E*_1 (set! x_x v_new)))
          (store ((x_1 v_1) ... (x_x v_new) (x_2 v_2) ...) (in-hole E*_1 unspecified))
          "VSet")
     
     (--> (store ((x_1 v_1) ... (x_x v_x) (x_2 v_2) ...) (in-hole E*_1 x_x))
          (store ((x_1 v_1) ... (x_x v_x) (x_2 v_2) ...) (in-hole E*_1 v_x))
          "VLookup")
     
     (--> (in-hole P_1 (begin (values v_1 ...) e_1 e_2 ...))
          (in-hole P_1 (begin e_1 e_2 ...))
          "VSeq")
     
     (--> (in-hole P_1 (begin e_1))
          (in-hole P_1 e_1)
          "VTrivSeq")
     
     (--> (in-hole P_1 (if v_1 e_1 e_2))
          (in-hole P_1 e_1)
          (side-condition (not (eq? (term v_1) #f)))
          "VIfT")
     
     (--> (in-hole P_1 (if #f e_1 e_2))
          (in-hole P_1 e_2)
          "VIfF")
     
     (--> (in-hole P_1 (- n_1))
          (in-hole P_1 ,(- (term n_1)))
          "VNeg")))
  
  (define thunk? (test-match lang (lambda () e)))
  
  (define lc-subst
    (subst
     [(? symbol?) (variable)]
     [(? number?) (constant)]
     [`(lambda (,@(xs ...)) ,b)
       (all-vars xs)
       (build (lambda (vars body) `(lambda ,vars ,body)))
       (subterm xs b)]
     [`(,f ,@(xs ...))
       (all-vars '())
       (build (lambda (vars f . xs) `(,f ,@xs)))
       (subterm '() f)
       (subterms '() xs)]))
  
  (define (lc-subst-all terms values body)
    (foldl lc-subst body terms values))
    
  (provide lang reductions))
